
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>php微信开发之自定义菜单完整流程_php技巧 / iVAN</title>

    <meta name="description" content="php微信开发之自定义菜单完整流程_php技巧 一.自定义菜单概述 自定义菜单能够帮助公众号丰富界面,让用户更好更快地理解公众号的功能.开启自定义菜单后,公众号界面如图所示: 二.申请自定义菜单 个人订阅号使用微博认证.企业订阅号通过微信认证:可以申请到自定义菜单资格 服务号默认有菜单权限. 三.获得AppId 和AppSecert AppId和AppSecret在开发者中心-开发者ID中,可以找到. 四.获得Access Token 用appid和appsecert获得access token,接口为 https://api.weixin.">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">php微信开发之自定义菜单完整流程_php技巧</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p><strong>一、自定义菜单概述</strong></p>
<p>自定义菜单能够帮助公众号丰富界面，让用户更好更快地理解公众号的功能。开启自定义菜单后，公众号界面如图所示：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTEzODA0OTYxLmpwZw==.jpg"></p>
<p><strong>二、申请自定义菜单</strong></p>
<p>个人订阅号使用微博认证、企业订阅号通过微信认证；可以申请到自定义菜单资格</p>
<p>服务号默认有菜单权限。</p>
<p><strong>三、获得AppId 和AppSecert</strong></p>
<p>AppId和AppSecret在开发者中心-开发者ID中，可以找到。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTEzODQzNzU4LmpwZw==.jpg"></p>
<p><strong>四、获得Access Token</strong></p>
<p>用appid和appsecert获得access token，接口为</p>
<p>https://api.weixin.qq.com/cgi-bi ... mp;secret=APPSECRET</p>
<p>程序实现如下</p>
<pre>
$appid = "";
$appsecret = "";
$url = "https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&amp;appid=$appid&amp;secret=$appsecret";
$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
$output = curl_exec($ch);
curl_close($ch);
$jsoninfo = json_decode($output, true);
$access_token = $jsoninfo["access_token"];
</pre>
<p>你也可以直接在浏览器地址栏中，拼接出地址，执行后，获得如下数据</p>
<p><u>复制代码</u> 代码如下:</p>
<p>{"access_token":"N2L7KXa084WvelONYjkJ_traBMCCvy_UKmpUUzlrQ0EA2yNp3Iz6eSUrRG0bhaR_viswd50vDuPkY5nG43d1gbm-olT2KRMxOsVE08RfeD9lvK9lMguNG9kpIkKGZEjIf8Jv2m9fFhf8bnNa-yQH3g", </p>
<p><u>复制代码</u> 代码如下:</p>
<p>"expires_in":7200} </p>
<p>参数说明如下</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE0MDQyMTQwLmpwZw==.jpg"></p>
<p>其中的<br />
N2L7KXa084WvelONYjkJ_traBMCCvy_UKmpUUzlrQ0EA2yNp3Iz6eSUrRG0bhaR_viswd50vDuPkY5nG43d1gbm-olT2KRMxOsVE08RfeD9lvK9lMguNG9kpIkKGZEjIf8Jv2m9fFhf8bnNa-yQH3g<br />
就是access token。</p>
<p>或者使用官方的接口调试工具，地址为：<br />
https://mp.weixin.qq.com/debug/cgi-bin/apiinfo?t=index&amp;type=%E8%87%AA%E5%AE%9A%E4%B9%89%E8%8F%9C%E5%8D%95&amp;form=%E8%87%AA%E5%AE%9A%E4%B9%89%E8%8F%9C%E5%8D%95%E5%88%9B%E5%BB%BA%E6%8E%A5%E5%8F%A3%20/menu/create</p>
<p>使用网页调试工具调试自定义菜单接口</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE0MTQyNzYwLmpwZw==.jpg"></p>
<p>点击检查问题得，得到</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE0MjA5MDY3LmpwZw==.jpg"></p>
<p>这样也获得了access token</p>
<p><strong>五、组织菜单内容</strong></p>
<p>目前自定义菜单最多包括3个一级菜单，每个一级菜单最多包含5个二级菜单。一级菜单最多4个汉字，二级菜单最多7个汉字，多出来的部分将会以“...”代 替。请注意，创建自定义菜单后，由于微信客户端缓存，需要24小时微信客户端才会展现出来。建议测试时可以尝试取消关注公众账号后再次关注，则可以看到创 建后的效果。</p>
<p>目前自定义菜单接口可实现两种类型按钮，如下：</p>
<p><strong>click：</strong><br />
用户点击click类型按钮后，微信服务器会通过消息接口推送消息类型为event        的结构给开发者（参考消息接口指南），并且带上按钮中开发者填写的key值，开发者可以通过自定义的key值与用户进行交互；<br /><strong>view：</strong><br />
用户点击view类型按钮后，微信客户端将会打开开发者在按钮中填写的url值        （即网页链接），达到打开网页的目的，建议与网页授权获取用户基本信息接口结合，获得用户的登入个人信息。</p>
<p>接口调用请求说明</p>
<p>http请求方式：POST（请使用https协议） https://api.weixin.qq.com/cgi-bi ... _token=ACCESS_TOKEN</p>
<p>请求示例</p>
<pre>
{
 "button":[
  {
   "type":"click",
   "name":"今日歌曲",
   "key":"V1001_TODAY_MUSIC"
  },
  {
   "type":"click",
   "name":"歌手简介",
   "key":"V1001_TODAY_SINGER"
  },
  {
   "name":"菜单",
   "sub_button":[
   {
    "type":"view",
    "name":"搜索",
    "url":"http://www.soso.com/"
   },
   {
    "type":"view",
    "name":"视频",
    "url":"http://v.qq.com/"
   },
   {
    "type":"click",
    "name":"赞一下我们",
    "key":"V1001_GOOD"
   }]
  }]
} </pre>
<p>参数说明</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE0NDU3MTg2LmpwZw==.jpg"></p>
<p>返回结果</p>
<p>正确时的返回JSON数据包如下：</p>
<p>{"errcode":0,"errmsg":"ok"}</p>
<p>错误时的返回JSON数据包如下（示例为无效菜单名长度）：</p>
<p>{"errcode":40018,"errmsg":"invalid button name size"}</p>
<p>六、提交菜单内容给服务器</p>
<p>菜单的JSON结构为</p>
<pre>
{"button": [{"name":"天气预报","sub_button":[{"type":"click","name":"北京天气","key":"天气北 京"},
{"type":"click","name":"上海天气","key":"天气上海"},
{"type":"click","name":" 广州天气","key":"天气广州"},{"type":"click","name":"深圳天气","key":"天气深圳"},
{"type":"view","name":"本地天气","url":"http://m.hao123.com/a/tianqi"}]},
{"name":"方倍工作室","sub_button":[{"type":"click","name":"公司简 介","key":"company"},
{"type":"click","name":"趣味游戏","key":"游戏"}, {"type":"click","name":"讲个笑话","key":"笑话"}]}]} </pre>
<p>将以下代码保存为menu.php，并且在浏览器中运行该文件（比如 http://127.0.0.1/menu.php），将直接向微信服务器提交菜单</p>
<pre>
php 

$access_token = ""; 

$jsonmenu = '{
  "button":[
  {
   "name":"天气预报",
   "sub_button":[
   {
    "type":"click",
    "name":"北京天气",
    "key":"天气北京"
   },
   {
    "type":"click",
    "name":"上海天气",
    "key":"天气上海"
   },
   {
    "type":"click",
    "name":"广州天气",
    "key":"天气广州"
   },
   {
    "type":"click",
    "name":"深圳天气",
    "key":"天气深圳"
   },
   {
    "type":"view",
    "name":"本地天气",
    "url":"http://m.hao123.com/a/tianqi"
   }] 

  },
  {
   "name":"瑞雪",
   "sub_button":[
   {
    "type":"click",
    "name":"公司简介",
    "key":"company"
   },
   {
    "type":"click",
    "name":"趣味游戏",
    "key":"游戏"
   },
   {
    "type":"click",
    "name":"讲个笑话",
    "key":"笑话"
   }] 

  }]
}'; 

$url = "https://api.weixin.qq.com/cgi-bin/menu/create?access_token=".$access_token;
$result = https_request($url, $jsonmenu);
var_dump($result); 

function https_request($url,$data = null){
 $curl = curl_init();
 curl_setopt($curl, CURLOPT_URL, $url);
 curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
 curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
 if (!empty($data)){
  curl_setopt($curl, CURLOPT_POST, 1);
  curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
 }
 curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
 $output = curl_exec($curl);
 curl_close($curl);
 return $output;
}
?&gt;
</pre>
<p>或者使用官方的调试接口 使用网页调试工具调试该接口</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE0OTUyMjcxLmpwZw==.jpg"></p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE1MDA2MDY2LmpwZw==.jpg"></p>
<p>提交成功后，重新关注后即可看到菜单。菜单效果类似如下：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2gub3NzLWNuLWhhbmd6aG91LmFsaXl1bmNzLmNvbS8yMDE2MTA4MTE1MDI1OTU0LmpwZw==.jpg"></p>
<p><strong>七、响应菜单点击事件</strong></p>
<p>在消息接口中处理event事件,其中的click代表菜单点击,通过响应菜单结构中的key值回应消息，view事件无须响应，将直接跳转过去</p>
<pre>
define("TOKEN", "weixin"); 

$wechatObj = new wechatCallbackapiTest();
if (!isset($_GET['echostr'])) {
  $wechatObj-&gt;responseMsg();
}else{
  $wechatObj-&gt;valid();
} 

class wechatCallbackapiTest
{
  public function valid()
  {
    $echoStr = $_GET["echostr"];
    if($this-&gt;checkSignature()){
      echo $echoStr;
      exit;
    }
 } 

  private function checkSignature()
  {
    $signature = $_GET["signature"];
   $timestamp = $_GET["timestamp"];
    $nonce = $_GET["nonce"]; 

   $token = TOKEN;
    $tmpArr = array($token, $timestamp, $nonce);
    sort($tmpArr);
    $tmpStr = implode( $tmpArr );
    $tmpStr = sha1( $tmpStr ); 

    if( $tmpStr == $signature ){
      return true;
    }else{
      return false;
    }
  } 

  public function responseMsg()
  {
    $postStr = $GLOBALS["HTTP_RAW_POST_DATA"];
    if (!empty($postStr)){
      $postObj = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);
    $RX_TYPE = trim($postObj-&gt;MsgType); 

     switch ($RX_TYPE)
      {
        case "text":
          $resultStr = $this-&gt;receiveText($postObj);
          break;
        case "event":
         $resultStr = $this-&gt;receiveEvent($postObj);
          break;
        default:
          $resultStr = "";
         break;
      }
      echo $resultStr;
    }else {
      echo "";
     exit;
    }
  } 

  private function receiveText($object)
  {
    $funcFlag = 0;
    $contentStr = "你发送的内容为：".$object-&gt;Content;
    $resultStr = $this-&gt;transmitText($object, $contentStr, $funcFlag);
    return $resultStr;
  } 

  private function receiveEvent($object)
  {
    $contentStr = "";
    switch ($object-&gt;Event)
    {
      case "subscribe":
        $contentStr = "欢迎洋洋博客";
      case "unsubscribe":
        break;
      case "CLICK":
        switch ($object-&gt;EventKey)
        {
          case "company":
            $contentStr[] = array("Title" =&gt;"公司简介",
            "Description" =&gt;"洋洋的博客",
            "PicUrl" =&gt;"http://discuz.comli.com/weixin/weather/icon/cartoon.jpg",
            "Url" =&gt;"weixin://addfriend/pondbaystudio");
            break;
          default:
            $contentStr[] = array("Title" =&gt;"默认菜单回复",
            "Description" =&gt;"您正在使用的是&lt;span style="font-family: Arial, Helvetica, sans-serif;"&gt;洋洋的博客&lt;/span&gt;&lt;span style="font-family: Arial, Helvetica, sans-serif;"&gt;", &lt;/span&gt;
            "PicUrl" =&gt;"http://discuz.comli.com/weixin/weather/icon/cartoon.jpg",
            "Url" =&gt;"weixin://addfriend/pondbaystudio");
            break;
        }
        break;
      default:
        break;    

    }
    if (is_array($contentStr)){
      $resultStr = $this-&gt;transmitNews($object, $contentStr);
    }else{
      $resultStr = $this-&gt;transmitText($object, $contentStr);
   }
    return $resultStr;
  } 

  private function transmitText($object, $content, $funcFlag = 0)
  {
    $textTpl = "&lt;xml&gt;
&lt;ToUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/ToUserName&gt;
&lt;FromUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/FromUserName&gt;
&lt;CreateTime&gt;%s&lt;/CreateTime&gt;
&lt;MsgType&gt;&lt;![CDATA[text]]&gt;&lt;/MsgType&gt;
&lt;Content&gt;&lt;![CDATA[%s]]&gt;&lt;/Content&gt;
&lt;FuncFlag&gt;%d&lt;/FuncFlag&gt;
&lt;/xml&gt;";
    $resultStr = sprintf($textTpl, $object-&gt;FromUserName, $object-&gt;ToUserName, time(), $content, $funcFlag);
    return $resultStr;
  } 

  private function transmitNews($object, $arr_item, $funcFlag = 0)
  {
    //首条标题28字，其他标题39字
    if(!is_array($arr_item))
      return; 

    $itemTpl = "  &lt;item&gt;
    &lt;Title&gt;&lt;![CDATA[%s]]&gt;&lt;/Title&gt;
    &lt;Description&gt;&lt;![CDATA[%s]]&gt;&lt;/Description&gt;
    &lt;PicUrl&gt;&lt;![CDATA[%s]]&gt;&lt;/PicUrl&gt;
    &lt;Url&gt;&lt;![CDATA[%s]]&gt;&lt;/Url&gt;
  &lt;/item&gt;
";
    $item_str = "";
    foreach ($arr_item as $item)
      $item_str .= sprintf($itemTpl, $item['Title'], $item['Description'], $item['PicUrl'], $item['Url']); 

    $newsTpl = "&lt;xml&gt;
&lt;ToUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/ToUserName&gt;
&lt;FromUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/FromUserName&gt;
&lt;CreateTime&gt;%s&lt;/CreateTime&gt;
&lt;MsgType&gt;&lt;![CDATA[news]]&gt;&lt;/MsgType&gt;
&lt;Content&gt;&lt;![CDATA[]]&gt;&lt;/Content&gt;
&lt;ArticleCount&gt;%s&lt;/ArticleCount&gt;
&lt;Articles&gt;
$item_str&lt;/Articles&gt;
&lt;FuncFlag&gt;%s&lt;/FuncFlag&gt;
&lt;/xml&gt;"; 

   $resultStr = sprintf($newsTpl, $object-&gt;FromUserName, $object-&gt;ToUserName, time(), count($arr_item), $funcFlag);
    return $resultStr;
  }
}
?&gt;
</pre>
<p><strong>八、菜单中获取OpenID</strong></p>
<p>由于菜单中只能填写固定的url地址，对于想要菜单中获取用户的OpenID的情况，可以使用OAuth2.0授权的方式来实现。</p>
<p>URL中填写的地址为一个固定的回调地址。原理方法可以参考  微信公众平台开发(99) 自定义菜单获取OpenID</p>
<pre>
&lt;?php
/*
  洋洋的博客
*/ 

define("TOKEN", "weixin");
$wechatObj = new wechatCallbackapiTest();
if (isset($_GET['echostr'])) {
  $wechatObj-&gt;valid();
}else{
  $wechatObj-&gt;responseMsg();
} 

class wechatCallbackapiTest
{
  public function valid()
  {
    $echoStr = $_GET["echostr"];
    if($this-&gt;checkSignature()){
      header('content-type:text');
      echo $echoStr;
      exit;
    }
  } 

  private function checkSignature()
  {
    $signature = $_GET["signature"];
    $timestamp = $_GET["timestamp"];
    $nonce = $_GET["nonce"]; 

    $token = TOKEN;
    $tmpArr = array($token, $timestamp, $nonce);
    sort($tmpArr, SORT_STRING);
    $tmpStr = implode( $tmpArr );
    $tmpStr = sha1( $tmpStr ); 

    if( $tmpStr == $signature ){
      return true;
    }else{
      return false;
    }
  } 

  public function responseMsg()
  {
    $postStr = $GLOBALS["HTTP_RAW_POST_DATA"]; 

    if (!empty($postStr)){
      $postObj = simplexml_load_string($postStr, 'SimpleXMLElement', LIBXML_NOCDATA);
      $fromUsername = $postObj-&gt;FromUserName;
      $toUsername = $postObj-&gt;ToUserName;
      $keyword = trim($postObj-&gt;Content);
      $time = time();
      $textTpl = "&lt;xml&gt;
            &lt;ToUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/ToUserName&gt;
            &lt;FromUserName&gt;&lt;![CDATA[%s]]&gt;&lt;/FromUserName&gt;
            &lt;CreateTime&gt;%s&lt;/CreateTime&gt;
            &lt;MsgType&gt;&lt;![CDATA[%s]]&gt;&lt;/MsgType&gt;
            &lt;Content&gt;&lt;![CDATA[%s]]&gt;&lt;/Content&gt;
            &lt;FuncFlag&gt;0&lt;/FuncFlag&gt;
            &lt;/xml&gt;";
      if($keyword == "?" || $keyword == "？")
      {
        $msgType = "text";
        $contentStr = '当前时间是：'.date("Y-m-d H:i:s",time());
        $resultStr = sprintf($textTpl, $fromUsername, $toUsername, $time, $msgType, $contentStr);
        echo $resultStr;
      }
    }else{
      echo "";
      exit;
    }
  }
}
?&gt; </pre>
<p>以上就是本文的全部内容，希望对大家的学习有所帮助，也希望大家多多支持。</p>
<p>以上是小编为您精心准备的的内容，在的博客、问答、公众号、人物、课程等栏目也有的相关内容，欢迎继续使用右上角搜索按钮进行搜索php<br />
                    ，                微信<br />
                                    自定义菜单<br />
                                    用户自定义完整性、用户自定义完整性约束、自定义完整性、数据库自定义完整性、最完整的装修流程图解，以便于您获取更多的相关知识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-17 11:29:05</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/php/" title="php">php</a>, <a href="https://www.iamivan.net/tag/%e5%be%ae%e4%bf%a1/" title="微信">微信</a>, <a href="https://www.iamivan.net/tag/%e8%87%aa%e5%ae%9a%e4%b9%89%e8%8f%9c%e5%8d%95/" title="自定义菜单">自定义菜单</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>php微信开发之自定义菜单完整流程_php技巧的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOXYlqb.html" rel="bookmark">微信利用PHP创建自定义菜单的方法&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在使用通用接口前,你需要做以下两步工作: 1.拥有一个微信公众账号,并获取到appid和appsecret(在公众平台申请内测资格,审核通过后可获得) 2.通过获取凭证接口获取到access_token 注意: access_token是第三方访问api资源的票据: access_token对应于公众号是全局唯一的票据,重复获取将导致上次获取的access_token失效. 访问下面这个地址(注意替换你的appid和secret): https://api.weixin.qq.com/cgi-b			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Gqvgp.html" rel="bookmark">thinkphp微信开发（消息加密解密）&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				使用thinkphp官方的WeChat包,使用不同模式可以成功,但是安全模式就是不行,现将分析解决结果做下记录. 分析问题:           解密微信服务器消息老是不成功,下载下微信公众平台官方给出的解密文件和WechatCrypt.class.php进行比对发现也没有问题.用file_put_contents函数保存下解密后的文件进行分析.发现官方包解密的xml不是标准的xml格式,所以simplexml_load_string函数无法处理. /** * 对密文进行解密 * @param			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bol9vEM.html" rel="bookmark">php 微信开发获取用户信息如何实现&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				php 微信开发获取用户信息 获取用户信息的大致算法是 用户授权登录第三方网站, 重点:scope参数: snsapi_basic 静默登录,不需要用户授权,只能获取到openid: snsapi_userinfo ,需要用户点击授权,能获取到openid和所有用户信息: 第一步:先获取用户的code值: 第二步:根据code值去获取access_token,每次请求的值都不一样,如果没有使用,每五分钟更新一次: 第三步:根据access_token获取用户信息: 1.获取code代码实现: g			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPlkaqp.html" rel="bookmark">微信公众平台开发之自定义菜单&period;Net代码解析&lowbar;实用技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				用户自定义菜单制作时,需要用到access_token,我们直接使用前面讲解的IsExistAccess_Token()函数.我理解的微信公共平台里面菜单分为button和sub_button,即菜单和子菜单,这些菜单都有一个name的属性,类别分为click和view,click类有key属性:而view类有url属性,含有子菜单的菜单没有key属性也没有url属性.这些情况可以从下面的例子看出来. public void MyMenu() { string weixin1 = &quot;&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bE4doPz.html" rel="bookmark">微信公众平台开发&lpar;104&rpar; 自定义菜单扫一扫、发图片、发地理位置</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关键字:微信公众平台 自定义菜单 扫一扫 发图片 发地理位置作者:方倍工作室原文:http://www.cnblogs.com/txw1958/p/weixin-menu-new-type.html    自定义菜单能够帮助公众号丰富界面,让用户更好更快地理解公众号的重要功能.微信增加了点击菜单后调起扫一扫(支持二维码/一维码).发图片.发地理位置的能力,需开发实现.原有自定义菜单开发权限的公众号,均可获得以上能力. 在这篇微信公众平台开发教程中,我们将介绍如何在自定义菜单上开发扫一扫.发图片.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/ze0aq7p.html" rel="bookmark">微信公众平台自定义菜单开发示例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 腾讯微信3月19日正式公布公众平台自定义菜单功能.目前该功能仅提供给企业和机构,且内测资格需要申请.对于这一新增功能,目前仅有少数账号已经开通.至此,微信的商业化价值被进一步挖掘出来.   开发示例-公众平台自定义菜单&quot;&gt;     开发者可利用该功能为公众账号的会话界面底部增加自定义菜单.用户点击菜单中的选项,可以调出相应的回复信息或网页链接. 菜单创建接口说明 通过POST一个特定结构体,实现在微信客户端创建自定义菜单. 请求说明 http请求方式:POST https://api.w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mqg0w2z.html" rel="bookmark">微信公众平台开发&lpar;99&rpar; 自定义菜单获取OpenID</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				关键字 微信公众平台 自定义菜单 OpenID作者:方倍工作室原文:http://www.cnblogs.com/txw1958/p/weixin-menu-get-openid.html   在这篇微信公众平台开发教程中,我们将介绍如何在自定义菜单中获得用户的OpenID. 本篇开发教程的实质是微信自定义菜单及OAuth2.0授权的灵活运用. 本文分为以下两个部分: 拥有高级接口权限时的获取(基于view事件) 没有高级接口权限时的获取(基于click事件)   一.拥有高级接口权限 拥有高级			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zVXlxDM.html" rel="bookmark">微信公众平台自定义菜单接口开发（1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				 微信公众平台开发 微信公众平台开发者 微信公众平台开发模式 服务号 自定义菜单接口API 作者:方倍工作室原文:http://www.cnblogs.com/txw1958/archive/2013/04/19/weixin-menu1.html   一.获取权限 自定义菜单接口目前处于内测阶段,需要向腾讯官方申请权限.通过权限的账号将获得到appid和appsecret 然后通过appid和appsecret获取access_token https://api.weixin.qq.com/c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2RxR3b.html" rel="bookmark">微信公众平台自定义菜单接口API指南</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				微信公众平台开发模式自定义菜单接口API指南  开发实现方法,请查看  微信公众平台开发(58)自定义菜单   简介 开发者获取使用凭证(如何获取凭证)后,可以使用该凭证对公众账号的自定义菜单进行创建.查询和删除等操作. 自定义菜单接口可实现以下类型按钮: click(点击事件): 用户点击click类型按钮后,微信服务器会通过消息接口(event类型)推送点击事件给开发者,并且带上按钮中开发者填写的key值,开发者可以通过自定义的key值进行消息回复. 创建自定义菜单后,由于微信客户端缓存,需			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/dzZOPwb.html" rel="bookmark" class="title">Linux 系统裁剪笔记 4 （内核配置选项及删改）</a>
					<div>
						在menuconfig中配置,可以对进行Linux内核配置选项及删改.本文介绍详细配置方法.第一部分:全部删除Code maturity level options ---&gt; 代码成熟等级选项[ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/xpn6QWp.html" rel="bookmark" class="title">运用CodeSmith代码生引擎生成XML报表文件</a>
					<div>
						xml|生成xml 前段时间做WEB项目时接到一个任务,报表都导出EXCEL.不能用第三方的报表工具,那只能操作EXCEL Library来解决了. 第一种:在服务端调用COM写EXCEL发关到客户端 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlR2aOz.html" rel="bookmark" class="title">Python序列的切片操作与技巧</a>
					<div>
						序列 序列(consequence)是python中一种数据结构,这种数据结构根据索引来获取序列中的对象. python中含有六种内建序列类:list, tuple, string, unicode, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPa6Kz.html" rel="bookmark" class="title">拟出一个计划</a>
					<div>
						第一步是决定在后面的过程中采取哪些步骤.这听起来似乎很简单(事实上,我们这儿说的一切都似乎很简单),但很常见的一种情况是:有些人甚至没有进入阶段1,便忙忙慌慌地开始编写代码.如果你的计划本来就是&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK746ab.html" rel="bookmark" class="title">【&period;Net Micro Framework PortingKit &ndash; 14】TinyCLR编译与测试</a>
					<div>
						由于TinyCLR的相关代码与硬件无关,我们所做的就是根据实际需要,添加不同的Feature,此外就是合理配置 堆栈和代码存储位置.其主要工作,具体地来说就是搞定\Solutions\STM3210E ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7GanM.html" rel="bookmark" class="title">J2EE的异步消息机制&lpar;下&rpar;</a>
					<div>
						三.消息驱动豆简介 异步消息也可以由消息驱动豆来实现.在EJB 1.1规范中,定义了两种类型的EJB.分别是实体豆(Entity Bean)和会话豆(Session Bean).客户端通常是以同步的, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1RLArp.html" rel="bookmark" class="title">WPS 2010 新版应用体验</a>
					<div>
						5月4日,金山软件正式推出WPSOffice2010个人版.据说,该版本融入了金山新一代V8文字排版引擎技术,产品性能跨越性提升,并兼容微软最新的Office2010文档格式.同时,WPSOffice ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4eKOp.html" rel="bookmark" class="title">AI&plus;PS打造童话梦境般的3D字体特效</a>
					<div>
						  1.通常人们在夜间做梦,所以我们把主色调调成青色和石灰绿. 2.同时,排版的时候来个完整的氛围,给人感觉像是在讲一个故事. 3.在操作时关于字体.树木.树枝.树叶.山峰.月亮.画布请逐一添加编组以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxWZnQb.html" rel="bookmark" class="title">读《应试教育的死穴，恰在于堵死了孩子&OpenCurlyDoubleQuote;犯错&rdquo;的空间》有感</a>
					<div>
						读&lt;应试教育的死穴,恰在于堵死了孩子&quot;犯错&quot;的空间&gt;有感          &quot;科技创新带来的利润最高,同时在生产要素(资源.能源.劳动力)已经达到极限的时候, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze67xwb.html" rel="bookmark" class="title">jsp-有关JSP方面的问题求大神帮忙</a>
					<div>
						问题描述 有关JSP方面的问题求大神帮忙 用JSP做一个信息管理系统的话已经实现单机访问修改了, 当实现多机访问修改数据时怎么避免数据不同步,,,(我用的javabean和servlet) 希望大神帮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MydgaPb.html" rel="bookmark" class="title">magento 1&period;4-- 推荐插件 -- 新的图片放大镜插件 -- Cloudzoom</a>
					<div>
						    插件名称:    CloudzoomExtension Key:magento-community/Cloudzoom网址:   http://www.magentocommerce.com/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL74xkM.html" rel="bookmark" class="title">用c语言修改win7注册表的启动项</a>
					<div>
						问题描述 用c语言修改win7注册表的启动项 求一段c语言修改win7注册表的代码,是修改注册表启动项的代码,本人主要用于学习,谢谢了 解决方案 RegSetValueEx					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnKJQ0z.html" rel="bookmark" class="title">WCF宿主WINFORM多客户端操作变慢</a>
					<div>
						问题描述 使用WINFORM作为WCF宿主,使用两个客户端同时查询表的时候查询速度会变慢,WINFORM宿主界面会无响应,查找不到问题原因,请教各位大神们帮忙附上设计代码:&lt;?xmlversio ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRoL1b.html" rel="bookmark" class="title">用手机从锁定的计算机中偷取凭证信息</a>
					<div>
						了解到这一点之后,我们就可以尝试用Android网络共享功能--也就是所谓的Tethering来创建网络.启用网络共享功能之后,手机设备就能够接收来自主机的所有通信数据,手机是作为网关存在.这样一来要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8YlQNz.html" rel="bookmark" class="title">脚本代码编辑器该怎么做？</a>
					<div>
						问题描述 有一款游戏的任务编辑器,里面可以用Lua写脚本,但它的代码编辑器并不好用,比如我写个变量,再次用到它的时候就没有其他提示,比如自动完成,自动验证这个变量是不是对的,因为可以随手写一个全局变量 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdyaPxz.html" rel="bookmark" class="title">《PADS 9&period;5电路设计与仿真从入门到精通》&mdash;&mdash;1&period;2　PCB设计的基础</a>
					<div>
						1.2 PCB设计的基础 PADS 9.5电路设计与仿真从入门到精通1.2.1 PCB设计的一般原则 1．印制电路板的设计 设计印制电路板首先从确定板的尺寸大小开始,印制电路板的尺寸因受机箱外壳大小限 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RvGnz.html" rel="bookmark" class="title">实现二次登录的时候，公司服务器与环信服务器的交互。</a>
					<div>
						问题描述 本帖最后由 seemse 于 2015-6-3 10:17 编辑 实现二次登录的时候,先登录我们公司的服务器,然后在登录环信的服务器,在iOS和Android调用SDF的时候,和环信服务器通 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mx0nO0M.html" rel="bookmark" class="title">开源大数据周刊-第22期</a>
					<div>
						阿里云E-Mapreduce动态 E-Mapreduce团队 1.5.0版本(正在研发) 增加集群整体运行情况的仪表盘 访问OSS不需要写id.key,增强安全性 集群其中后,可以重启.修改配置及安装 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqW7Zkz.html" rel="bookmark" class="title">详解为Angular&period;js内置&dollar;http服务添加拦截器的方法&lowbar;AngularJS</a>
					<div>
						前言 在Angular框架中,创建团队为使用者进行了Ajax请求的封装,并通过$http服务暴露出相关的接口.Angular在其官方文档中指出, $http服务底层针对Web常见的安全攻击做出了相应的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwKKrEz.html" rel="bookmark" class="title">javascript学习笔记（六）数据类型和JSON格式&lowbar;基础知识</a>
					<div>
						什么是JSON JSON:JavaScript 对象表示法(JavaScript Object Notation). JSON的形式是用大括号&quot;{}&quot;包围起来的项目列表,每一个项目 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QX7mp.html" rel="bookmark" class="title">关于网站外链质量的重要性分析</a>
					<div>
						一条高质量的外链甚至可以抵过一堆的垃圾外链,只有长期稳定的外链才能让你网站关键词排名处在长期稳定的状态下.那么,怎样才算是稳定的外链?B2B?分类信息?论坛?其实这些都只是短暂的外链,因此小陈个人不推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z44Bwjz.html" rel="bookmark" class="title">WIN2000 Apache php mysql 安装及安全手册&lowbar;服务器</a>
					<div>
						look: 本文写给想在win2k平台上架设一个安全web站台的朋友们. 所需要的程序: apache http://www.apache.org/dist/httpd/binaries/win32/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmVwKlz.html" rel="bookmark" class="title">spring-eclipse部署项目到tomcat根目录发现的问题？</a>
					<div>
						问题描述 eclipse部署项目到tomcat根目录发现的问题? 通过eclipse把项目部署到tomcat根目录,通过在项目上右击-Properties-Web Project Settings-C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Earb.html" rel="bookmark" class="title">跨平台跨设备应用或将成为一个热点</a>
					<div>
						移动智能设备的流行也带来一些问题,那就是场景不同,设备不同,共存和共享的能力变得成为一种潜在的需求.或许有一些应用本身可以带来这种共享或者衔接,但是在多个设备之间呢?比如手机.电视.平板.可穿戴设备, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk8ooM.html" rel="bookmark" class="title">移动监控在安防行业的应用分析</a>
					<div>
						一.移动监控的发展 移动安防的应用范围广泛,不仅仅深入到了之前的安防产业业务范围,还创造出了许多新的业务形态,从大型安防项目到民用安防项目都有涉及.大型移动安防项目如平安城市.智能交通等;民用移动安防 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pn47oZb.html" rel="bookmark" class="title">XWiki 6&period;3 M1 发布，Java 的 Wiki 系统</a>
					<div>
						XWiki 6.3 M1 发布,此版本主要是系统改进,同时引入了新的 Velocity 工具和 macros:同时支持捕获和显示 Velocity 的异常. XWiki 6.3 M1 包括超过 85  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlAmAqp.html" rel="bookmark" class="title">&lbrack;LeetCode&rsqb; Odd Even Linked List</a>
					<div>
						Given a singly linked list, group all odd nodes together followed by the even nodes. Please note her ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7w66Zz.html" rel="bookmark" class="title">《Adobe After Effects CS4经典教程》&mdash;&mdash;导读</a>
					<div>
						前 言 Adobe After Effects CS4提供了一套完整的2D和3D工具,动态影像专业人员.视频特效艺术家.网页设计人员以及电影和视频专业人员可以用这些工具创建合成图像.动画和特效.Aft ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQWxD8p.html" rel="bookmark" class="title">&OpenCurlyDoubleQuote;海洋&rdquo;对Google至关重要的原因</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 现在你可以通过GoogleEart ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVd5gYM.html" rel="bookmark" class="title">IP 欲求不满&quest;物联网与 IPv6 联姻</a>
					<div>
						每次提起物联网这个词,我们都可以看到人们不遗余力地用最专业的市场术语说着它的好与坏.伴随着物联网概念的兴起,很多机会也随之而来:通过物联网,你可以实时查看你家的用电量,了解车况,并通过可穿戴设备监控健 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.038 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
